Option Explicit
DefInt A-Z
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Declarations for ShellExecute
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function ShellExecute Lib "Shell.dll" (ByVal hWnd%, ByVal lpszOp$, ByVal lpszFile$, ByVal lpszParams As Any, ByVal lpszDir$, ByVal fsShowCnd%) As Integer
Declare Function IsIconic Lib "User" (ByVal hWnd%) As Integer
Declare Function ShowWindow Lib "User" (ByVal hWnd%, ByVal nCmdShow%) As Integer
Global Const SW_MAXIMIZE = 3
Global Const SW_RESTORE = 9
Global Const SW_MINIMIZE = 6
Global Const SW_HIDE = 0
Global Const SW_SHOW = 5


'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Declarations for Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function RegOpenKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName$, lpNewKeyHand&) As Long
Declare Function RegQueryValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName As Any, ByVal lpRes As String, lenResBuff&) As Long
Declare Function RegCloseKey Lib "SHELL.DLL" (lpNewKeyHand&) As Long
Declare Function RegCreateKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName$, lpNewKeyHand&) As Long
Declare Function RegSetValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKey As Any, ByVal fdwType&, ByVal KeyText$, ByVal lenKeyText&) As Long
Declare Function RegEnumKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKeyIndex As Long, ByVal KeyText$, ByVal lenKeyText&) As Long
Declare Function RegDeleteKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKey As Any) As Long
Global Const Reg_SZ = 1
Global Const ERROR_SUCCESS = 0
Global Const HKEY_CLASSES_ROOT = 1

Declare Function GetWindowLong& Lib "User" (ByVal hWnd%, ByVal nIndex%)
Declare Function SetWindowLong& Lib "User" (ByVal hWnd%, ByVal nIndex%, ByVal dwNewLong&)
Global Const LBS_NOINTEGRALHEIGHT = &H100&

Sub CenterForm (F As Form)
Dim x%, Y%
x% = (screen.Width - F.Width) / 2
Y% = (screen.Height - F.Height) / 2
F.Move x%, Y%
End Sub

Function CheckReg (Ext$, op%) As Integer
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Look for print command in Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim x&, NewKey&, KeyName$, Y&, Result$
Const lRes& = 80
Result$ = String$(lRes&, 0)
KeyName$ = "." + Ext$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Exit if Ext$ not listed in Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If RegOpenKey(HKEY_CLASSES_ROOT, KeyName$, NewKey&) <> ERROR_SUCCESS Then Exit Function
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get Identifier for this key
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
x& = RegQueryValue(NewKey&, 0&, Result$, lRes&)
Y& = RegCloseKey(NewKey&)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * exit if no identifier found
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If x& <> ERROR_SUCCESS Then Exit Function
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get print command
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim o$
Select Case op%
Case 0
    o$ = "\shell\open"
Case 1
    o$ = "\shell\print"
Case 2
    
Case Else
 
End Select
If op% < 2 Then
    Result$ = Left$(Result$, InStr(Result$, Chr$(0)) - 1) + o$
Else
    Result$ = o$
End If
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * exit if no print command
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If RegOpenKey(HKEY_CLASSES_ROOT, Result$, NewKey&) = ERROR_SUCCESS Then
    'Result$ = Left$(Result$, InStr(Result$, Chr$(0)) - 1) + o$
    Debug.Print Result$
'    If op% < 2 Then
 '       Form1.GroupPush3D1(op%).Enabled = True
Select Case op%
Case 0
 '   Form1.Image2(0).Enabled = True
 '   Form1.Image2(0).Picture = Form1.Image2(1).Picture
Case 1
 '   Form1.Image3(0).Enabled = True
 '   Form1.Image3(0).Picture = Form1.Image3(1).Picture
'Case 2
'    Exit Function
End Select



'Else Exit Function
End If
'Exit Function 'GoTo Fail
Y& = RegCloseKey(NewKey&)
CheckReg = True
End Function

Function Confirm% (Ask$)
If MsgBox(Ask$, 52, App.Title) = 6 Then Confirm% = True
End Function

Function ExtractPath (ByVal PathName As String) As String
' Return the directory path portion of a full pathname
    Dim F$, N%
    F$ = PathName
    Do
        N% = InStr(F$, "\")
        If N% > 0 Then F$ = Right$(F$, Len(F$) - N%)
    Loop While N% > 0
    ExtractPath = Left$(PathName, Len(PathName) - Len(F$))
End Function

Function GetExtType$ (Ext$)
Dim x&, NewKey&, KeyName$, Y&, Result$, op%
op% = 0
Const lRes& = 80
Result$ = String$(lRes&, 0)
KeyName$ = "." + Ext$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Exit if Ext$ not listed in Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If RegOpenKey(HKEY_CLASSES_ROOT, KeyName$, NewKey&) <> ERROR_SUCCESS Then Exit Function
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get Identifier for this key
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
x& = RegQueryValue(NewKey&, 0&, Result$, lRes&)
Y& = RegCloseKey(NewKey&)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * exit if no identifier found
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If x& <> ERROR_SUCCESS Then Exit Function
If InStr(Result$, Chr$(0)) > 1 Then
    GetExtType$ = Left$(Result$, InStr(Result$, Chr$(0)) - 1)
Else
   GetExtType$ = " "
End If
End Function

Function GetRegData$ (Ext$, op%, ComType%)
  GetRegData = " "
  'op%=1 print
  'op%=2 open
  'op%=3 returns DDE topic or app
  'ComType%=1 returns command line
  'ComType%=2 returns DDE command
  'ComType%=3 returns DDE topic
  'ComType%=4 returns DDE application
  Dim NewKey&, lRes&, tmpLong&, Result$, KeyName$, Buffer$
  NewKey& = 0
  lRes& = 80
  Result$ = String$(80, 0)
  KeyName$ = "." + Ext$ + Chr$(0)
  '  * Exit if Ext$ not listed in Registration Database
  If RegOpenKey(HKEY_CLASSES_ROOT, KeyName$, NewKey&) <> 0 Then Exit Function
  '  * get Identifier for this key
  Dim x&, Y&
  x& = RegQueryValue(NewKey&, 0&, Result$, Len(Result$))
  Y& = RegCloseKey(NewKey&)
  '  * exit if no identifier found
  If x& <> 0 Then Exit Function
  '  * get handle of print command
  Result$ = Left$(Result$, InStr(Result$, Chr$(0)) - 1) + "\shell\"
  Select Case op%
  Case 1
    Result$ = Result$ + "print"
  Case 2
    Result$ = Result$ + "open"
  Case 3
    Result$ = Result$ + "open\ddeexec"
  End Select
  '  * exit if no print command
  If RegOpenKey(HKEY_CLASSES_ROOT, Result$, NewKey&) <> ERROR_SUCCESS Then
    Result$ = ""
    Exit Function
  End If
  ' now get the print command
  Buffer$ = String$(80, 0)
  Select Case ComType%
  Case 1
    Result$ = "command"
  Case 2
    Result$ = "ddeexec"
  Case 3
    Result$ = "topic"
  Case 4
    Result$ = "application"
  End Select
  lRes& = 80
  If RegQueryValue(NewKey&, Result$, Buffer$, Len(Buffer$)) <> ERROR_SUCCESS Then
    Result$ = " "
  Else
    Result$ = Left$(Buffer$, InStr(Buffer$, Chr$(0)) - 1)
  End If
  Y& = RegCloseKey(NewKey&)
  GetRegData$ = Result$
  End Function

