Option Explicit
DefInt A-Z
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  global vars
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Global DLLCommand%
Global LoopCounter%
Global HidePM%
Global AboutButtonVis%
Global CopyRight$
Global Edition$
Dim C As Control
Global CRLF$
Global Groups%()
Global MeIconic%
Global Reloading% 'flag used when reloading menus to skip form/unload proc.
Global tMenuCount%
Global ShowHiddenWindows%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  module-level vars
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim Progs() As String
Dim WorkDirs() As String
Dim Registered%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *'DMENU.DLL calls
'  * DMENU.DLL declare
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function WatchDesk% Lib "DMENU.DLL" (ByVal MyWin%, ByVal OnOff%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * TrackPopupMenu declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function TrackPopupMenu% Lib "user" (ByVal hMenu%, ByVal wFlags%, ByVal X%, ByVal Y%, ByVal r2%, ByVal hWnd%, ByVal r1&)
Declare Function GetMenu% Lib "user" (ByVal hWnd%)
Declare Function GetSubMenu% Lib "user" (ByVal hMenu%, ByVal nPos%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * cursor positioning declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Type POINTAPI
   X As Integer
   Y As Integer
End Type
Declare Sub GetCursorPos Lib "User" (lpPoint As POINTAPI)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * shell declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function ShellExecute Lib "Shell.dll" (ByVal hWnd%, ByVal lpszOp$, ByVal lpszFile$, ByVal lpszParams As Any, ByVal lpszDir$, ByVal fsShowCnd%) As Integer
Global Const SW_SHOW = 5
Const SW_MINIMIZE = 6
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * ExitWindows declare
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function ExitWindows Lib "User" (ByVal dwReserved As Long, ByVal wReturnCode As Integer) As Integer
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * hide progman declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Declare Function IsWindowVisible Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function IsIconic Lib "User" (ByVal hWnd As Integer) As Integer
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  arrange icons declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function GetDesktopWindow Lib "User" () As Integer
Declare Function ArrangeIconicWindows Lib "User" (ByVal hWnd As Integer) As Integer
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * window placement declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Type RECT
  Left As Integer
  Top As Integer
  Right As Integer
  Bottom As Integer
End Type
Type WindowPlacement
  Length As Integer
  Flags As Integer
  ShowCmd As Integer
  PtMinPosition As POINTAPI
  ptMaxPosition As POINTAPI
  rcNormalPosition As RECT
End Type
Declare Function SetWindowPlacement% Lib "USER" (ByVal hWnd%, lpwndpl As WindowPlacement)
Declare Function GetWindowPlacement% Lib "USER" (ByVal hWnd%, lpwndpl As WindowPlacement)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * private INI declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Task list declares
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Global Const GW_HWNDFIRST = 0
Global Const GW_HWNDNEXT = 2
Declare Function GetWindow% Lib "USER" (ByVal hWnd%, ByVal wCmd%)
Declare Function GetWindowTextLength% Lib "USER" (ByVal hWnd%)
Declare Function GetWindowText% Lib "USER" (ByVal hWnd%, ByVal lpString$, ByVal aint%)
Declare Function GetClassName% Lib "USER" (ByVal hWnd%, ByVal lpClassName$, ByVal nMaxCount%)
Declare Function SetActiveWindow Lib "User" (ByVal hWnd As Integer) As Integer

Sub BuildTaskMenu ()
Dim CurrWnd, Length, ListItem$, X, CT%
Dim cName As String * 255
' Get the hWnd of the first item in the master list
CurrWnd = GetWindow(MainFrm.hWnd, GW_HWNDFIRST)
' Loop while the hWnd returned by GetWindow is valid.
While CurrWnd <> 0
'* Get the length of the task name identified by
'* CurrWnd in the list.
   Length = GetWindowTextLength(CurrWnd)
'* Get the task name of the task in the master list.
   ListItem$ = Space$(Length + 1)
   Length = GetWindowText(CurrWnd, ListItem$, Length + 1)
'strip time from listing if vb clock running
   Dim vbc%
   vbc% = InStr(ListItem$, Chr$(160))
   If vbc% Then ListItem$ = Left$(ListItem$, vbc% - 1)
'strip crlf$ if there
   vbc% = InStr(ListItem$, CRLF$)
   If vbc% Then ListItem$ = Left$(ListItem$, vbc% - 1)
'* item to the list.
'* If there is an actual task name in the list
   If Length > 0 Then
      X = GetClassName(CurrWnd, cName, 254)
      'if it's not a hidden vb window
      If Left$(cName, 13) <> "ThunderRTMain" Then
	 'add a new menu item
	 If IsWindowVisible(CurrWnd) Or ShowHiddenWindows% = True Then
	    CT% = CT% + 1
	    If CT% > 1 Then Load MainFrm.tMenu(CT% - 1)
	    MainFrm.tMenu(CT% - 1).Caption = ListItem$
	    MainFrm.tMenu(CT% - 1).Tag = CurrWnd
	    tMenuCount = CT% - 1
	 End If
      End If
   End If
'* Get the next task list item in the master list.
   CurrWnd = GetWindow(CurrWnd, GW_HWNDNEXT)
Wend
End Sub

Sub cChecker (X%, tCt%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  *  sets object var C to specified menu item
'  *
'  *  X%=subMenu
'  *  tCt%=counter indicates which item on submenu
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Select Case X%
Case 0
   Set C = MainFrm.asM(tCt%)
Case 1
   Set C = MainFrm.bsM(tCt%)
Case 2
  Set C = MainFrm.csM(tCt%)
Case 3
   Set C = MainFrm.dsM(tCt%)
Case 4
   Set C = MainFrm.esM(tCt%)
Case 5
   Set C = MainFrm.fsM(tCt%)
Case 6
   Set C = MainFrm.gsM(tCt%)
Case 7
   Set C = MainFrm.hsM(tCt%)
Case 8
   Set C = MainFrm.isM(tCt%)
Case 9
   Set C = MainFrm.jsM(tCt%)
Case 10
   Set C = MainFrm.ksM(tCt%)
Case 11
   Set C = MainFrm.lsM(tCt%)
Case 12
   Set C = MainFrm.msM(tCt%)
Case 13
   Set C = MainFrm.nsM(tCt%)
Case 14
   Set C = MainFrm.osM(tCt%)
Case 15
   Set C = MainFrm.psM(tCt%)
Case 16
   Set C = MainFrm.qsM(tCt%)
Case 17
   Set C = MainFrm.rsM(tCt%)
Case 18
   Set C = MainFrm.ssM(tCt%)
Case 19
   Set C = MainFrm.tsM(tCt%)
Case 20
   Set C = MainFrm.usM(tCt%)
Case 21
   Set C = MainFrm.vsM(tCt%)
Case 22
   Set C = MainFrm.wsM(tCt%)
Case 23
   Set C = MainFrm.xsM(tCt%)
Case 24
   Set C = MainFrm.ysM(tCt%)
Case 25
   Set C = MainFrm.zSM(tCt%)
Case 26
   Set C = MainFrm.aaSM(tCt%)
Case 27
   Set C = MainFrm.bbSM(tCt%)
Case 28
   Set C = MainFrm.ccSM(tCt%)
Case 29
   Set C = MainFrm.ddSM(tCt%)
Case 30
   Set C = MainFrm.eeSM(tCt%)
Case 31
   Set C = MainFrm.ffSM(tCt%)
Case 32
   Set C = MainFrm.GGSM(tCt%)
Case 33
   Set C = MainFrm.HHSM(tCt%)
Case 34
   Set C = MainFrm.iiSM(tCt%)
Case 35
   Set C = MainFrm.jjSM(tCt%)
Case 36
   Set C = MainFrm.KKSM(tCt%)
Case 37
   Set C = MainFrm.llSM(tCt%)
Case 38
   Set C = MainFrm.mmSM(tCt%)
Case 39
   Set C = MainFrm.nnSM(tCt%)
End Select
End Sub

Sub CenterControl (C As Control, F As Form)
C.Left = (F.Width - C.Width) / 2
End Sub

Sub CenterForm (F As Form)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * center specified form on screen
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
F.Left = (Screen.Width - F.Width) / 2
F.Top = (Screen.Height - F.Height) / 2
End Sub

Sub CheckProgMan ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * make PM visible
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim X%
X% = FindWindow("ProgMan", 0&)
If IsWindowVisible(X%) = False Then
   X% = ShowWindow(X%, SW_SHOW)
   X% = ArrangeIconicWindows(GetDesktopWindow())
End If
End Sub

Sub cLoader (X%, CT%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * loads specified menu control
'  * then calls cChecker
'  *
'  * X%=SubMenu
'  * Ct%=counter indicating which item on submenu
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Select Case X%
Case 0
   Load MainFrm.asM(CT%)
Case 1
   Load MainFrm.bsM(CT%)
Case 2
   Load MainFrm.csM(CT%)
Case 3
   Load MainFrm.dsM(CT%)
Case 4
   Load MainFrm.esM(CT%)
Case 5
   Load MainFrm.fsM(CT%)
Case 6
   Load MainFrm.gsM(CT%)
Case 7
   Load MainFrm.hsM(CT%)
Case 8
   Load MainFrm.isM(CT%)
Case 9
   Load MainFrm.jsM(CT%)
Case 10
   Load MainFrm.ksM(CT%)
Case 11
   Load MainFrm.lsM(CT%)
Case 12
   Load MainFrm.msM(CT%)
Case 13
   Load MainFrm.nsM(CT%)
Case 14
   Load MainFrm.osM(CT%)
Case 15
   Load MainFrm.psM(CT%)
Case 16
   Load MainFrm.qsM(CT%)
Case 17
   Load MainFrm.rsM(CT%)
Case 18
   Load MainFrm.ssM(CT%)
Case 19
   Load MainFrm.tsM(CT%)
Case 20
   Load MainFrm.usM(CT%)
Case 21
   Load MainFrm.vsM(CT%)
Case 22
   Load MainFrm.wsM(CT%)
Case 23
   Load MainFrm.xsM(CT%)
Case 24
   Load MainFrm.ysM(CT%)
Case 25
   Load MainFrm.zSM(CT%)
Case 26
   Load MainFrm.aaSM(CT%)
Case 27
   Load MainFrm.bbSM(CT%)
Case 28
   Load MainFrm.ccSM(CT%)
Case 29
   Load MainFrm.ddSM(CT%)
Case 30
   Load MainFrm.eeSM(CT%)
Case 31
   Load MainFrm.ffSM(CT%)
Case 32
   Load MainFrm.GGSM(CT%)
Case 33
   Load MainFrm.HHSM(CT%)
Case 34
   Load MainFrm.iiSM(CT%)
Case 35
   Load MainFrm.jjSM(CT%)
Case 36
   Load MainFrm.KKSM(CT%)
Case 37
   Load MainFrm.llSM(CT%)
Case 38
   Load MainFrm.mmSM(CT%)
Case 39
   Load MainFrm.nnSM(CT%)
End Select
cChecker X%, CT%
End Sub

Sub DestroyTaskMenu ()
Dim X%
For X% = tMenuCount% To 1 Step -1
   On Error Resume Next
   Unload MainFrm.tMenu(X%)
Next
End Sub

Sub Frame (F As Form, L, t, h, W, Style)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * draws 3D frame on control at specified
'  * left, top, height, width
'  * concave or convex depending upon Style param
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Const HiColor = &HFFFFFF
Const LoColor = &H808080
Dim BigOffSet
BigOffSet = 10
F.DrawWidth = 1
F.ForeColor = HiColor:  If Style = 2 Then F.ForeColor = LoColor
'bottom:
F.Line (L + F.DrawWidth, t + h)-(L + W - F.DrawWidth, t + h)
'right:
F.Line (L + W, t + F.DrawWidth)-(L + W, t + h - F.DrawWidth)
F.ForeColor = LoColor: If Style = 2 Then F.ForeColor = HiColor
'top:
 F.Line (L - BigOffSet + F.DrawWidth, t - BigOffSet)-(L + W + BigOffSet - F.DrawWidth, t - BigOffSet)
'left:
F.Line (L - BigOffSet, t + F.DrawWidth - BigOffSet)-(L - BigOffSet, t + h + BigOffSet - F.DrawWidth)
End Sub

Sub GetConfig (ShowIcons%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * read string from private INI file
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim IniString As String * 255, X%
X% = GetPrivateProfileString("Settings", "HideIcons", "0", IniString, 255, "Start.INI")
ShowIcons% = Val(Left$(IniString, InStr(IniString, Chr$(0)) - 1))
X% = GetPrivateProfileString("Settings", "ShowHiddenTasks", "0", IniString, 255, "Start.INI")
ShowHiddenWindows% = Val(Left$(IniString, InStr(IniString, Chr$(0)) - 1))
End Sub

Sub GetExe (Temp$, ProgCt%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * examine progman data string for Run Minimized flag
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim Min%
For Min% = Len(Temp$) To 1 Step -1
   If Mid$(Temp$, Min%, 1) = "," Then Exit For
Next
If Mid$(Temp$, Min% + 1, 1) = "1" Then
   Min% = True
Else
   Min% = False
End If
Dim i%, C1%, C2%, AppExe$, AppPath$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * extract command line and working dir from progman data
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C1% = InStr(Temp$, ",")
If C1% Then
   C2% = InStr(C1% + 1, Temp$, ",")
   AppExe$ = Left$(Temp$, C2% - 2)
   AppExe$ = Mid$(AppExe$, C1% + 2)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * append flag if to run minimized
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   If Min% = True Then AppExe$ = AppExe$ + "DTMRunMin"
   Progs(ProgCt%) = AppExe$
   C1% = InStr(C2% + 1, Temp$, ",")
   AppPath$ = Left$(Temp$, C1% - 1)
   AppPath$ = Mid$(AppPath$, C2% + 1)
   WorkDirs(ProgCt%) = AppPath$
End If
End Sub

Sub GetGroups ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * load program group names from ProgMan
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainFrm.Caption = "Loading."
GetLinkData "PROGMAN"
Dim i%, X%, Temp$, CT%
CRLF$ = Chr$(13) + Chr$(10)
Temp$ = MainFrm.Text1
i% = InStr(Temp$, CRLF$)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * add each name to sorter list box
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Do While i%
   HelloFrm.sorter.AddItem Left$(Temp$, i% - 1)
   Temp$ = Mid$(Temp$, i% + 2)
   i% = InStr(Temp$, CRLF$)
   CT% = CT% + 1
Loop
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * now take from list box and assign to menu captions
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
For X% = 0 To CT% - 1
   MainFrm.GroupMenu(X%).Caption = HelloFrm.sorter.List(X%)
Next
ReDim Groups%(CT% - 1)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * now hide unused menus
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
For i% = CT% To 39
   MainFrm.GroupMenu(i%).Visible = False
Next
HelloFrm.sorter.Clear
End Sub

Sub GetItems ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get menu items for each program group
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim i%, X%, CT%, Cap$, Temp$, Y%
Dim AccumGroup%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * loop through all groups
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
For X% = 0 To 39
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * animate Start icon caption
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   If X% / 2 = Int(X% / 2) Then
     MainFrm.Caption = MainFrm.Caption + "."
   End If
   i% = DoEvents()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  get all program items for current group
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   If MainFrm.GroupMenu(X%).Visible = True Then
      Temp$ = MainFrm.GroupMenu(X%).Caption
      GetLinkData Temp$
      Temp$ = MainFrm.Text1
      i% = InStr(Temp$, CRLF$)
      Cap$ = Left$(Temp$, i% - 1)
      Cap$ = Trim(Cap$)
      i% = InStr(Cap$, ",")
      i% = InStr(i% + 1, Cap$, ",")
      Cap$ = Mid$(Cap$, i% + 1)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * hide menu if no items in group
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      If Val(Cap$) = 0 Then
	    MainFrm.GroupMenu(X%).Visible = False
      End If
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * redim arrays to hold items in this group
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      Groups%(X%) = AccumGroup%
      AccumGroup% = AccumGroup% + Val(Cap$)
      ReDim Preserve Progs(AccumGroup%)
      ReDim Preserve WorkDirs(AccumGroup%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * strip off 1st line of label
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      i% = InStr(Temp$, CRLF$)
      If i% Then
	 Temp$ = Mid$(Temp$, i% + 2)
	 i% = InStr(Temp$, CRLF$)
      End If
      CT% = 0
     ' Debug.Print Temp$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * set initial value of C to existing menu item
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      cChecker X%, 0
      Do While i%
	 C.Visible = True
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * add item's data to sorter
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 HelloFrm.sorter.AddItem Left$(Temp$, InStr(Temp$, CRLF$) - 1)
	 Temp$ = Mid$(Temp$, i% + 2)
	 i% = InStr(Temp$, CRLF$)
	 CT% = CT% + 1
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * if there's another item, load another menu item
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 If i% Then cLoader X%, CT%
      Loop
      CT% = 0
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * loop through sorter list box
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      For Y% = 0 To HelloFrm.sorter.ListCount - 1
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * extract command line/work dir
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 Cap$ = HelloFrm.sorter.List(Y%)
	 GetExe Cap$, Groups%(X) + Y%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * now trim caption
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 Cap$ = Left$(Cap$, InStr(Cap$, ",") - 1)
	 Cap$ = Mid$(Cap$, 2, Len(Cap$) - 2)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * select object variable
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 cChecker X%, CT%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * set menu caption
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 C.Caption = Cap$
	 CT% = CT% + 1
      Next Y%
   End If
   HelloFrm.sorter.Clear
Next X%
End Sub

Sub GetLinkData (Item$)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * establish DDE link with ProgMan
'  * request Item$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainFrm.Text1.LinkTopic = "ProgMan|Progman"
MainFrm.Text1.LinkItem = Item$
MainFrm.Text1.LinkMode = 2
MainFrm.Text1.LinkRequest
On Error Resume Next
MainFrm.Text1.LinkMode = 0
On Error GoTo 0
End Sub

Sub HideEm ()
HideIconicApp FindWindow("ProgMan", 0&)
If MeIconic% Then
    If MainFrm.Left > 0 Then MoveIconOffScreen MainFrm
End If
End Sub

Sub HideIconicApp (Handle%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * if specified window is iconic and visible, hide it
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If IsIconic(Handle%) <> False And IsWindowVisible(Handle%) <> 0 Then
   Handle% = ShowWindow(Handle%, SW_HIDE)
End If
End Sub

Sub HideIcons ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  hide or display pm and Start icons
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim X%, Y%
If MainFrm.deskMenu(3).Checked Then
    HidePM% = True:
    HideEm
    X% = ArrangeIconicWindows(GetDesktopWindow())
Else
   HidePM% = False
   X% = FindWindow("ProgMan", 0&)
   X% = ShowWindow(X%, SW_SHOW)
   X% = ArrangeIconicWindows(GetDesktopWindow())
End If
LoopCounter% = False
End Sub

Sub Main ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * sub main() is startup routine for StartMenu
'  *
'  * prevent multiple instances
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If App.PrevInstance Then AppActivate "StartMenu": End
CRLF$ = Chr$(13) + Chr$(10)
CopyRight$ = "Copyright  1994 by Paul Bonner" + CRLF$ + "All Rights Reserved"
Edition$ = "As Seen in Windows Sources"
App.Title = "StartMenu"
Dim X%
MainFrm.Show
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * disable menu until fully customized
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainFrm.MyMenu.Enabled = False
HelloFrm.Show
X% = DoEvents()
Screen.MousePointer = 11
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get progman data
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
GetGroups
GetItems
MainFrm.Caption = "StartMenu"
Screen.MousePointer = 0
Unload HelloFrm
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * enable menu, minimize main form
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainFrm.MyMenu.Enabled = True
MainFrm.WindowState = 1
MeIconic% = True
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * hide Start and progman icons if indicated by INI
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim ShowIcons%
GetConfig ShowIcons%
If ShowIcons% = True Then ProcessDeskMenuItem 3
If ShowHiddenWindows% = True Then ProcessDeskMenuItem 4

'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * subclass desktop window
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
On Error GoTo DLLError
X% = WatchDesk(MainFrm.hWnd, True)
'Const WM_RBUTTONDOWN = &H204
'MainFrm.MsgBlaster1.hWndTarget = GetDesktopWindow()
'MainFrm.MsgBlaster1.MsgList(0) = WM_RBUTTONDOWN




On Error GoTo 0
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * enter endless loop
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Do While DoEvents()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * pop up menu if command received from dll
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   If DLLCommand% = 127 Then
     BuildTaskMenu
      TrackPopUp 0, MainFrm: DLLCommand% = False
      DestroyTaskMenu
  End If
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  if supposed to hide icons
'  look for them every 100 trips through loop
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   If HidePM% = True Then
      LoopCounter% = LoopCounter% + 1
      If LoopCounter% = 100 Then
	 HideEm
	 LoopCounter% = 0
      End If
   End If
Loop
Exit Sub
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * end if can't access DLL
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
DLLError:
   If Err = 48 Then
      MsgBox "Can't load DMENU.DLL"
   Else
      MsgBox "Error loading DLL: " + Str$(Err)
   End If
   End
End Sub

Sub MoveIconOffScreen (F As Form)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * move Start icon off screen
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Const WPF_SETMINPOSITION = &H1
Dim WinPlace As WindowPlacement, X%
WinPlace.Length = 22
X% = GetWindowPlacement%(F.hWnd, WinPlace)
WinPlace.PtMinPosition.Y = -50 '-75
WinPlace.PtMinPosition.X = -50 '-75
WinPlace.Flags = WPF_SETMINPOSITION
Const SW_HIDE = 0
WinPlace.ShowCmd = SW_MINIMIZE
'WinPlace.ShowCmd = SW_HIDE
X% = SetWindowPlacement%(F.hWnd, WinPlace)
End Sub

Sub ProcessDeskMenuItem (Index As Integer)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * process Start menu selections
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Select Case Index
Case 0
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * load about form
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
   AboutButtonVis% = True
   Load HelloFrm
   HelloFrm.Show 1
Case 1
   ReloadMenus
Case 2
Case 3
   MainFrm.deskMenu(3).Checked = Not MainFrm.deskMenu(3).Checked
   HideIcons
Case 4
    MainFrm.deskMenu(4).Checked = Not MainFrm.deskMenu(4).Checked
    ShowHiddenWindows% = MainFrm.deskMenu(4).Checked
Case 5
Case 6
   
   Unload MainFrm
End Select
End Sub

Sub ProcessSpecialMenu (Ind%)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * process Windows menu selections
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim X%, Reboot%
Select Case Ind%
Case 0
   X% = MsgBox("Restart Windows now?", 49, "StartMenu")
   If X% <> 1 Then Exit Sub
   Reboot% = &H42
Case 1
   X% = MsgBox("Exit Windows now?", 49, "StartMenu")
   If X% <> 1 Then Exit Sub
   Reboot% = &H0
End Select
X% = ExitWindows(Reboot%, 0)
End Sub

Sub ReloadMenus ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * unload MainFrm, then reload to reinitialize custom menus
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim OldCheck%
Reloading% = True
OldCheck% = MainFrm.deskMenu(3).Checked
Unload MainFrm
ReDim Groups%(0)
ReDim Progs(0)
ReDim WorkDirs(0)
MainFrm.Show
Reloading% = False
GetGroups
GetItems
Unload HelloFrm
MainFrm.Caption = "StartMenu"
Dim X%
X% = WatchDesk(MainFrm.hWnd, True)
MainFrm.deskMenu(3).Checked = OldCheck%
If OldCheck% Then HideIcons
End Sub

Sub RunProg (ProgtoRun%)
Dim X%, Temp$, Min%
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * look for run minimized flag
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Min% = InStr(Progs(ProgtoRun%), "DTMRunMin")
If Min% > 0 Then Progs(ProgtoRun%) = Left$(Progs(ProgtoRun%), Min% - 1)
X% = InStr(Progs(ProgtoRun%), ".")
If X% < 2 Then MsgBox "Can't run " & Progs(ProgtoRun%): Exit Sub
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * use ShellExecute to launch
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
On Error Resume Next
   If Min% > 0 Then
     X% = ShellExecute(MainFrm.hWnd, "open", Progs(ProgtoRun%), 0&, WorkDirs(ProgtoRun%), SW_MINIMIZE)
   Else
      X% = ShellExecute(MainFrm.hWnd, "open", Progs(ProgtoRun%), 0&, WorkDirs(ProgtoRun%), SW_SHOW)
   End If
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * if ShellExecute fails, try Shell
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If X% < 32 Then
   If Min% > 0 Then
      X% = Shell(Progs(ProgtoRun%), 2)
   Else
      X% = Shell(Progs(ProgtoRun%), 1)
   End If
End If
On Error GoTo 0
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * if still no success, announce failure
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If X% = 0 Then
   MsgBox "Can't run " & Progs(ProgtoRun%)
End If
End Sub

Sub SaveConfig ()
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * save data to private INI file
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim X%
X% = WritePrivateProfileString("Settings", "HideIcons", Str$(MainFrm.deskMenu(3).Checked), "Start.INI")
X% = WritePrivateProfileString("Settings", "ShowHiddenTasks", Str$(MainFrm.deskMenu(4).Checked), "Start.INI")
End Sub

Sub TrackPopUp (Menu As Integer, F As Form)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  API routine to track popup menu, with right mouse button
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim MD As POINTAPI
GetCursorPos MD
Dim hMenu%, hSubMenu%, r As Integer
hMenu% = GetMenu(F.hWnd)
hSubMenu% = GetSubMenu(hMenu%, Menu)
r = TrackPopupMenu(hSubMenu%, 2, MD.X, MD.Y, 0, F.hWnd, 0&)
End Sub

