DefInt A-Z
Option Explicit
Type PointAPI
     Y As Integer
     X As Integer
End Type
Global CurrentApp%
Global Keepers$() 'windows to keep on top
Global Minis$()   'windows to only keep on top when minimized
Global Mini%
Global Keep%
Global TopWins%()  'integer array  containing handles of all on-top windows
Global Target%
'Action modes
Global Action%
Const WaitingForButton = 10
Const ScanningKeys = 20
Global Const Minimized = 30
Global MP As PointAPI
Global fString As String * 73  'Fixed length string for API calls
Global wHnd%                   'handle for ID form
Global Res%                    'Topper command button result
Declare Sub GetCursorPos Lib "User" (P As PointAPI)
Declare Function WindowFromPoint Lib "User" (ByVal X As Integer, ByVal Y As Integer) As Integer
Declare Function GetParent Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetWindowText Lib "User" (ByVal hWnd As Integer, ByVal lpString As String, ByVal aint As Integer) As Integer
Declare Function IsWindowVisible Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetDesktopWindow Lib "User" () As Integer
'Declares for FormStayOnTop
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
Const Swp_Nosize = &H1
Const SWP_Nomove = &H2
Const Swp_NoActivate = &H10
Const Swp_ShowWindow = &H40
Const Hwnd_TopMost = -1
Const Hwnd_NoTopMost = -2
'Declares for Hotkey
Declare Function GetAsyncKeyState Lib "User" (ByVal VKCODE)
Const VK_Control = &H11
Const VK_RBUTTON = &H2
Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any, ByVal lplFileName$)
Declare Function WriteProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString$)
Declare Function GetProfileInt% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal nDefault%)
Declare Function GetPrivateProfileInt% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal nDefault%, ByVal lpFilename$)
Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFilename$)
Declare Function GetProfileString% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)
Declare Function GetClassName% Lib "USER" (ByVal hWnd%, ByVal lpClassName$, ByVal nMaxCount%)
Declare Function GetWindowTask% Lib "USER" (ByVal hWnd%)
Declare Function GetModuleFileName% Lib "KERNEL" (ByVal hModule%, ByVal lpFilename$, ByVal nSize%)
Declare Function IsIconic Lib "User" (ByVal hWnd As Integer) As Integer
'Declares for SearchWindowLIst
Declare Function GetWindow% Lib "USER" (ByVal hWnd%, ByVal wCmd%)
Global Const GW_HWNDFIRST = 0
Global Const GW_HWNDNEXT = 2
Declare Function GetWindowText Lib "User" (ByVal hWnd As Integer, ByVal lpString As String, ByVal aint As Integer) As Integer
Declare Function GetNumTasks Lib "Kernel" () As Integer

Type TaskEntry
  dwSize As Long
  hTask As Integer
  hTaskParent As Integer
  hInst As Integer
  hModule As Integer
  wSS As Integer
  wSP As Integer
  wStackTop As Integer
  wStackMinimum As Integer
  wStackBottom As Integer
  wcEvents As Integer
  hQueue As Integer
  szModule As String
  wPSPOffset As Integer
  hNext As Integer
End Type
Declare Function TaskFindHandle% Lib "TOOLHELP.DLL" (lpTE As TaskEntry, ByVal hTask%)
Declare Function TaskFirst% Lib "TOOLHELP.DLL" (lpTE As TaskEntry)
Declare Function TaskNext% Lib "TOOLHELP.DLL" (lpTE As TaskEntry)
'undocumented
Declare Function GetExePtr Lib "Kernel" (ByVal hInst As Integer) As Integer


Declare Function GetClassWord% Lib "USER" (ByVal hWnd%, ByVal nIndex%)
Global Const GCW_HMODULE = -16
'returns handle of module
'then use getmodule filename
Type CLASSENTRY
  dwSize As Long
  hInst As Integer
  szClassName As String
  wNext As Integer
End Type
Declare Function GetModuleUsage% Lib "KERNEL" (ByVal hModule%)
Declare Function GetModuleHandle% Lib "KERNEL" (ByVal lpModuleName$)

Sub CheckControlStatus ()
Dim Test$, X%
For X% = 0 To 1
   Topper.Check1(X%).Value = 0
Next
Topper.Option1(1) = True
Test$ = GetExe$(Target%)

For X% = 0 To UBound(Minis$)
   If Trim$(Test$) = Trim$(Minis$(X%)) Then Topper.Check1(1).Value = 1
Next
For X% = 0 To UBound(Keepers$)
   If Test$ = Keepers$(X%) Then Topper.Check1(0).Value = 1
Next
For X% = 0 To 1
   If Topper.Check1(X%).Value = 1 Then Topper.Option1(0) = True
Next
For X% = 1 To UBound(TopWins%)
   If Target% = TopWins%(X%) Then Topper.Option1(0) = True
Next
End Sub

Sub DeletePrivIni (pApp$, pKey$, pFile$)
Dim X%
X% = WritePrivateProfileString%(pApp$, pKey$, 0&, pFile$)
End Sub

Sub EvalChecks ()
Dim X%, Y%, AppExe$
AppExe$ = GetExe$(Target%)
If Topper.Check1(1) = 1 Then    'only icon
   Mini% = Mini% + 1
   ReDim Preserve Minis$(Mini%)
   Minis$(Mini%) = AppExe$
   Topper.Timer1.Enabled = True
   PutPrivIni "IconOnly", AppExe$, "-1", "Topper.INI" 'add ini entry
   If IsIconic(Target%) <> 0 Then FormStayOnTop Target%, True
Else  'find entry in current minis list and remove
   FormStayOnTop Target%, True
   X% = UBound(Minis$)
   If X% > 0 Then
      For Y% = 1 To X%
         If Minis$(Y%) = AppExe$ Then
            Minis$(Y%) = ""
            DeletePrivIni "IconOnly", AppExe$, "Topper.INI"  'delete ini entry
         End If
      Next
   End If
End If
                  
If Topper.Check1(0) = 1 Then  'always
   Keep% = Keep% + 1
   Topper.Timer1.Enabled = True
   ReDim Preserve Keepers$(Keep%)
   Keepers$(Keep%) = AppExe$
   PutPrivIni "Always", AppExe$, "-1", "Topper.INI" 'add ini entry
Else
   X% = UBound(Keepers$)
   If X% > 0 Then
      For Y% = 1 To X%
         If Keepers$(Y%) = AppExe$ Then
            Keepers$(Y%) = ""
            DeletePrivIni "Always", AppExe$, "Topper.INI" 'delete ini entry
         End If
      Next
   End If
End If
End Sub

Function FindTarget% ()
Dim hActive%, hParent%, hProgenitor%, temp%, X1%, Y1%, OldP%
GetCursorPos MP
X1% = MP.X
Y1% = MP.Y
' *** Active Window ***
hActive% = WindowFromPoint(X1%, Y1%)
If IsWindowVisible(hActive%) Then temp% = hActive%
' *** Parent Window ***
hParent% = GetParent(hActive%)
If IsWindowVisible(hParent%) Then temp% = hParent%
' *** Progenitor Window ***
Do While hParent%
   OldP% = hParent%
   If IsWindowVisible(OldP%) Then temp% = OldP%
   hParent% = GetParent(OldP%)
Loop
If OldP% Then temp% = OldP%
FindTarget% = temp%
End Function

Function FixAPIString$ (ByVal Test$)
FixAPIString$ = Trim(Left$(Test$, InStr(Test$, Chr$(0)) - 1))
End Function

Sub FormStayOnTop (handle%, OnTop%)
Dim wFlags As Integer, PosFlag As Integer, Y%
Static Tw%
wFlags = SWP_Nomove Or Swp_Nosize Or Swp_ShowWindow Or Swp_NoActivate
Select Case OnTop%       'Set window flags based on value of OnTop%
     Case True
        PosFlag = Hwnd_TopMost
        Tw% = Tw% + 1
        ReDim Preserve TopWins%(Tw%)
        TopWins%(Tw%) = handle%
     Case False
         PosFlag = Hwnd_NoTopMost
         For Y% = 0 To UBound(TopWins%)
          If TopWins%(Y%) = handle% Then TopWins%(Y%) = 0
         Next
     End Select
SetWindowPos handle%, PosFlag, 0, 0, 0, 0, wFlags
End Sub

Function GetExe$ (handle%)
Dim Y%, fTest As String * 255
Y% = GetClassWord%(handle%, GCW_HMODULE)
Y% = GetModuleFileName%(Y%, fTest, 255)
GetExe$ = FixAPIString$(fTest)
End Function

Function GetPrivINI$ (pApp$, pKey$, pDefault$, pFile$)
Dim X%
Dim Ret As String * 1024
X% = GetPrivateProfileString%(pApp$, pKey$, pDefault$, Ret, Len(Ret), pFile$)
If X% > 0 Then GetPrivINI$ = Left$(Ret, X%)
End Function




Function GetPrivIniInt% (pApp$, pKey$, pDefault%, pFile$)
GetPrivIniInt% = GetPrivateProfileInt%(pApp$, pKey$, pDefault%, pFile$)
End Function

Function GetWindowList$ (AppExe$, NumToFind%)
Dim w%, T$, found%
w% = GetWindow%(Topper.hWnd, GW_HWNDFIRST)
Do While w% <> 0
  If GetExe$(w%) = AppExe$ Then
      found% = found% + 1
      T$ = T$ + Str$(w) + "|"
      If found% = NumToFind% Then
         GetWindowList$ = T$
         Exit Function
      End If
   End If
   w% = GetWindow%(w%, GW_HWNDNEXT)
Loop
End Function

Function GetWinIni$ (pApp$, key$, pDefault$, pFile$)
Dim pKey As Variant
If key$ = "" Then
   pKey = 0&
Else
   pKey = key$
End If
Dim X%
Dim Ret As String * 1024
X% = GetPrivateProfileString%(pApp$, pKey, pDefault$, Ret, Len(Ret), pFile$)
If X% > 0 Then GetWinIni$ = Left$(Ret, X%)
End Function

Function GetWinIniInt% (pApp$, pKey$, pDefault%)
GetWinIniInt% = GetProfileInt%(pApp$, pKey$, pDefault%)
End Function

Sub InitIni ()
Dim X%, T$, z%, a$
z% = 0
T$ = ListPrivateIniEntries$("IconOnly", "Topper.INI")
If T$ <> "" Then
   X% = InStr(T$, Chr$(0))
   Do While X% > 1
      Mini% = Mini% + 1
      ReDim Preserve Minis$(Mini%)
      Minis$(Mini%) = FixAPIString$(Mid$(T$, z% + 1, X%))
'      Debug.Print Minis$(Mini%); Mini%
      z% = X%
      X% = InStr(X% + 1, T$, Chr$(0))
   Loop
End If

z% = 0
T$ = ListPrivateIniEntries$("Always", "Topper.INI")
If T$ <> "" Then
   X% = InStr(T$, Chr$(0))
   Do While X% > 1
      Keep% = Keep% + 1
      ReDim Preserve Keepers$(Keep%)
      Keepers$(Keep%) = FixAPIString$(Mid$(T$, z% + 1, X%))
 '     Debug.Print Keepers$(Keep%); Keep%
      z% = X%
      X% = InStr(X% + 1, T$, Chr$(0))
   Loop
End If
If Keep% > 0 Or Mini% > 0 Then Topper.Timer1.Enabled = True
End Sub

Function ListPrivateIniEntries$ (pApp$, pFile$)
Dim X%
Dim Ret As String * 4096
X% = GetPrivateProfileString%(pApp$, 0&, "", Ret, Len(Ret), pFile$)
If X% > 0 Then ListPrivateIniEntries$ = Left$(Ret, X%)
End Function

Sub Main ()
Dim hActive%, hParent%, hProgenitor%, hDesk%, TargetCap$, X%, GC%, OldWin%
ReDim Minis$(0), Keepers$(0)
hDesk% = GetDesktopWindow%()
Topper.Show        'show form
Action% = ScanningKeys
InitIni
Do While DoEvents()     'Loop forevermore
   Select Case Action%
      Case Minimized   'if minimized, do nothing
      Case WaitingForButton
         If Res% Then   'User picked OK or Cancel button
            If Res% = 1 Then 'OK
               If Topper.Option1(0) = True Then 'keep on top
                  EvalChecks
               Else  'don't keep on top
                  RemoveTop Target%
               End If
            Else  'cancel button
            End If
            MakeSmallForm
            Res% = 0
            Action% = ScanningKeys
         End If
      Case ScanningKeys
            'id the window under cursor
         Target% = FindTarget()
            'display info about Target%
         If Target% <> hDesk% Then
            If Target% <> OldWin% Then
               'Topper.Dat(0) = Str$(target%)
               'GC = GetWindowText(target%, fString, 72)
               'Topper.Dat(1) = FixAPIString$(fString)
               Topper.Dat = GetExe$(Target%)
               'TargetCap$ = Topper.Dat(1)
               Topper.Refresh
               OldWin% = Target%
            End If
         Else
            Topper.Dat = ""
            Target% = 0
            OldWin% = 0
         End If   'Valid Target Check%
            'if control-right click and a valid target then
         If GetAsyncKeyState(VK_RBUTTON) And GetAsyncKeyState(VK_Control) Then
            Do Until (GetAsyncKeyState(VK_RBUTTON) And GetAsyncKeyState(VK_Control)) = False
            Loop
            If Target% <> 0 Then
               MakeBigForm 'expand form
               Action% = WaitingForButton
            End If   'valid target check
         End If   'end key check
   End Select  'action switch
Loop
End Sub

Sub MakeBigForm ()
'need to evaluate current settings for this app/set check marks/options accordingly
Dim X%
Topper.Height = 3650
For X% = 0 To 1
   Topper.Option1(X%).Visible = True
   Topper.Command1(X%).Visible = True
   Topper.L1(X%).Visible = True
   Topper.Command1(X%).Visible = True
Next
Topper.L1(3).Visible = True
Topper.L1(0).Y1 = 2620
Topper.L1(0).Y2 = 2620
Topper.L1(3).Y1 = Topper.L1(0).Y1 - 30
Topper.L1(3).Y2 = Topper.L1(0).Y2 - 30
Topper.Label1.Top = 2700
Topper.Label1 = "Click OK to make selected window stay on top."
CheckControlStatus
End Sub

Sub MakeSmallForm ()
Dim X%
For X% = 0 To 1
   Topper.Option1(X%).Visible = False
   Topper.Command1(X%).Visible = False
Next
Topper.L1(1).Visible = False
Topper.L1(3).Visible = False

Topper.L1(0).Y1 = 960
Topper.L1(0).Y2 = 960
Topper.L1(2).Y1 = Topper.L1(0).Y1 - 30
Topper.L1(2).Y2 = Topper.L1(0).Y2 - 30


Topper.Label1.Top = 1080
Topper.Height = 1960
Topper.Label1 = "Click Ctrl-Rt. button to select target window."
End Sub

Function OnMiniList% (Test$)
Dim X%, z%
z% = UBound(Minis$)
If z% = 0 Then Exit Function
For X% = 1 To z%
   If Minis$(X%) = Test$ Then OnMiniList% = True: Exit Function
Next
End Function

Sub PutPrivIni (pApp$, pKey$, pString$, pFile$)
Dim X%
X% = WritePrivateProfileString%(pApp$, pKey$, pString$, pFile$)
End Sub

Sub PutWinIni (pApp$, pKey$, pString$)
Dim X%
X% = WriteProfileString%(pApp$, pKey$, pString$)
End Sub

Sub RemoveTop (Target%)
Dim AppExe$
AppExe$ = GetExe$(Target%)
FormStayOnTop Target%, False
DeletePrivIni "IconOnly", AppExe$, "Topper.INI"  'delete ini entry
DeletePrivIni "Always", AppExe$, "Topper.INI" 'delete ini entry
'get it out of the arrays
 Dim X%
 For X% = 1 To UBound(Minis$)
   If Minis$(X%) = AppExe$ Then Minis$(X%) = ""
 Next
 For X% = 1 To UBound(Keepers$)
   If Keepers$(X%) = AppExe$ Then Keepers$(X%) = ""
 Next
End Sub

Function SearchWindowListEXEs% (AppExe$, StartWin%)
Dim w%, T$
w% = GetWindow%(StartWin%, GW_HWNDFIRST)
Do While w% <> 0
   w% = GetWindow%(w%, GW_HWNDNEXT)
   If GetExe$(w%) = AppExe$ Then SearchWindowListEXEs% = w%: Exit Function
Loop
End Function

