Option Explicit
DefInt A-Z
Global Interval%
Global Code$
Global ratDollars%
Global ratCents%
Global CurrSet%
Global Sets%
Global MyRate!
Global SetChanged%
Global Ini$
'Declares for INI file routines
Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any, ByVal lplFileName$)
Declare Function WriteProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any)
Declare Function GetProfileInt% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal nDefault%)
Declare Function GetPrivateProfileInt% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal nDefault%, ByVal lpFilename$)
Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFilename$)
Declare Function GetProfileString% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)

Sub CenterForm (F As Form)
F.Left = (Screen.Width - F.Width) / 2
F.Top = (Screen.Height - F.Height) / 2
End Sub

Sub DetermineRate ()
If ratDollars% + ratCents% = False Then Exit Sub
MyRate! = ratDollars% + ratCents% / 100
End Sub

Function GetPrivINI$ (pApp$, pkey$, pDefault$, pFile$)
Dim X%
Dim ret As String * 1024
X% = GetPrivateProfileString%(pApp$, pkey$, pDefault$, ret, Len(ret), pFile$)
If X% > 0 Then GetPrivINI$ = Left$(ret, X%)
End Function

Function GetPrivIniInt% (pApp$, pkey$, pDefault%, pFile$)
GetPrivIniInt% = GetPrivateProfileInt%(pApp$, pkey$, pDefault%, pFile$)
End Function

Sub PutPrivIni (pApp$, pkey$, pString$, pFile$)
Dim X%
X% = WritePrivateProfileString%(pApp$, pkey$, pString$, pFile$)
End Sub

Sub ReadMenuItem (X%)
Dim S$
S$ = "SET" & X%
Code$ = GetPrivINI$(S$, "Name", "Unnamed", Ini$)
Interval% = GetPrivIniInt%(S$, "Interval", 0, Ini$)
ratDollars% = GetPrivIniInt%(S$, "Dollars", 0, Ini$)
ratCents% = GetPrivIniInt%(S$, "Cents", 0, Ini$)
End Sub

Sub SaveMenuItem (SetNum%)
Dim S$
S$ = "SET" & SetNum%
PutPrivIni S$, "Name", Code$, Ini$
PutPrivIni S$, "Interval", Str$(Interval%), Ini$
PutPrivIni S$, "Dollars", Str$(ratDollars%), Ini$
PutPrivIni S$, "Cents", Str$(ratCents%), Ini$
End Sub

